<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>A Minimal jQuery Replacement</title>
</head>
<body>
    <button id="hello">Hello All The Time</button>
    <button id="hi">Hello Once</button>
    <button id="write">Write Something</button>
	<p id="output">Click button 3 to set this text.</p>
	<button id="createButton"  onclick="createElement()">Add new DOM Element</button><br/><br/>
	<div id="dynamicContent"></div>
    <script src="js/dom_utils.js"></script>
    <script src="js/dom_utils_global.js"></script>
    <script>
        /* global $live */
        // here we will use the 'U' object defined in the utils script file

        // first select the hello button
        // then add a click listener
        /*
        var helloButton = U.$('hello');
        var clickAction = function() { alert('Well HELLO!'); };
        */
        //U.addEvent(helloButton, 'click', clickAction);
        $live('#hello', 'click', function() { 
            alert('Well HELLO!'); 
        });
        
        // this one removes the listener after a click
        /*
        var helloOnce = U.$('hi');
        var alertOnce = function() {
            alert('Well HELLO!');
            U.removeEvent(helloOnce, 'click', alertOnce);
        };
        U.addEvent(helloOnce, 'click', alertOnce);
        */
        
        var shown = false;
        var alertOnce = function() {
            if(shown) {
                return;
            }
            shown = true;
            alert('Well HELLO!');
//            this.setAttribute('id','null');
//            window.qs('#hi').id = 'null';
//            this.removeEventListener('click',alertOnce);
        };
        $live('#hi', 'click', alertOnce);
        
        /*
        var writeText = U.$('write');
        U.addEvent(writeText, 'click', function() {
            U.setText('output', "Writing some new text for you.");
        });
        */
        
        $live('#write', 'click', function() {
            window.qs('#output').innerText = "Writing some new text for you.";
        });
        
        // Dynamically creating DOM elements, they all have same functionality as the first button
        window.onload = function() {
            window.qs('#createButton').onclick = function() {
                var element = document.createElement("BUTTON");
                element.id = "hello";
                var text = document.createTextNode("Hello All The Time"); 
                element.appendChild(text);
                document.getElementById("dynamicContent").appendChild(element);
            }
        }
    </script>
</body>
</html>